
%module wkf

%{
#include <wkf.h>

/* fix me!! */
#define STRING_LEN_TIMES 10

static void print_guess_file(FILE *fin, int detail)
{
  wkfPrintGuessedKanjiCodeOfFile(fin, RTEST(detail) ? 1 : 0);
}

static int guess_file(FILE *fin) {
  return wkfGuessKanjiCodeOfFile(fin);
}

static int guess_string(char *str) {
  return wkfGuessKanjiCodeOfString(str);
}

static int guess(char *str) {
  return wkfGuessKanjiCodeOfString(str);
}

static void convert_file(FILE *fin, int kout, FILE *fout, int kin)
{
  int ret_val;

  ret_val = wkfConvertKanjiCodeOfFile(kin, fin, kout, fout);
  if (ret_val == CONV_ERR) {
    rb_raise(rb_eRuntimeError, "Convert Error!!");
  }
}

static VALUE convert_string(char *sin, int kout, int kin)
{
  int ret_val;
  int len;
  char *buf;

  len = strlen(sin);
  buf = ALLOCA_N(char, len * STRING_LEN_TIMES);
  ret_val = wkfConvertKanjiCodeOfString(kin, sin, kout, buf, sizeof(char) * len * STRING_LEN_TIMES);
  if (ret_val == CONV_ERR) {
    rb_raise(rb_eRuntimeError, "Convert Error!!");
  }

  return rb_str_new2(buf);
}

static VALUE wkf(char *sin, int kout, int kin)
{
  int ret_val;
  int len;
  char *buf;

  len = strlen(sin);
  buf = ALLOCA_N(char, len * STRING_LEN_TIMES);
  ret_val = wkfConvertKanjiCodeOfString(kin, sin, kout, buf, sizeof(char) * len * STRING_LEN_TIMES);
  if (ret_val == CONV_ERR) {
    rb_raise(rb_eRuntimeError, "Convert Error!!");
  }

  return rb_str_new2(buf);
}

static VALUE tojis(char *str)
{
  int ret_val;
  int len;
  char *buf;

  len = strlen(str);
  buf = ALLOCA_N(char, len * STRING_LEN_TIMES);
  ret_val = wkfConvertKanjiCodeOfString(KC_UNKNOWN, str, KC_JIS, buf, sizeof(char) * len * STRING_LEN_TIMES);
  if (ret_val == CONV_ERR) {
    rb_raise(rb_eRuntimeError, "Convert Error!!");
  }

  return rb_str_new2(buf);
}

static VALUE toeuc(char *str)
{
  int ret_val;
  int len;
  char *buf;

  len = strlen(str);
  buf = ALLOCA_N(char, len * STRING_LEN_TIMES);
  ret_val = wkfConvertKanjiCodeOfString(KC_UNKNOWN, str, KC_EUC, buf, sizeof(char) * len * STRING_LEN_TIMES);
  if (ret_val == CONV_ERR) {
    rb_raise(rb_eRuntimeError, "Convert Error!!");
  }

  return rb_str_new2(buf);
}

static VALUE tosjis(char *str)
{
  int ret_val;
  int len;
  char *buf;

  len = strlen(str);
  buf = ALLOCA_N(char, len * STRING_LEN_TIMES);
  ret_val = wkfConvertKanjiCodeOfString(KC_UNKNOWN, str, KC_SJIS, buf, sizeof(char) * len * STRING_LEN_TIMES);
  if (ret_val == CONV_ERR) {
    rb_raise(rb_eRuntimeError, "Convert Error!!");
  }

  return rb_str_new2(buf);
}

static void set_line_end_code(int lineend)
{
  wkfSetLineEndCode(lineend);
}

static void set_zenkaku2ascii_mode(VALUE flag)
{
  switch(TYPE(flag)) {
  case T_TRUE:
    wkfConvertZenkaku2ASCII(1);
    break;
  case T_FALSE:
    wkfConvertZenkaku2ASCII(0);
    break;
  default:
  }
}

static VALUE encode_base64(char *str)
{
  int ret_val;
  int len;
  char *buf;

  len = strlen(str);
  buf = ALLOCA_N(char, len * STRING_LEN_TIMES);
  ret_val = wkfDecodeBase64String(str, buf, sizeof(char) * len * STRING_LEN_TIMES);
  if (ret_val == -1) {
    rb_raise(rb_eRuntimeError, "Convert Error!!");
  }

  return rb_str_new2(buf);
}

static VALUE decode_base64(char *str)
{
  int ret_val;
  int len;
  char *buf;

  len = strlen(str);
  buf = ALLOCA_N(char, len * STRING_LEN_TIMES);
  ret_val = wkfDecodeBase64String(str, buf, sizeof(char) * len * STRING_LEN_TIMES);
  if (ret_val == -1) {
    rb_raise(rb_eRuntimeError, "Convert Error!!");
  }

  return rb_str_new2(buf);
}

static void decode_base64_file(FILE *fin, FILE *fout)
{
  wkfDecodeBase64File(fin, fout);
}

static VALUE encode_qp(char *str)
{
  int ret_val;
  int len;
  char *buf;

  /* fix me(1000)!! */
  len = strlen(str);
  buf = ALLOCA_N(char, len * 1000);
  ret_val = wkfEncodeQuotedPrintableString(str, buf, sizeof(char) * len * 1000);

  return rb_str_new2(buf);
}

static VALUE decode_qp(char *str)
{
  int ret_val;
  int len;
  char *buf;

  len = strlen(str);
  buf = ALLOCA_N(char, len * STRING_LEN_TIMES);
  ret_val = wkfDecodeQuotedPrintableString(str, buf, sizeof(char) * len * STRING_LEN_TIMES);
  if (ret_val == -1) {
    rb_raise(rb_eRuntimeError, "Convert Error!!");
  }

  return rb_str_new2(buf);
}

static void decode_qp_file(FILE *fin, FILE *fout)
{
  wkfDecodeQuotedPrintableFile(fin, fout);
}

static VALUE decode_mime(char *str, int kout)
{
  int ret_val;
  int len;
  char *buf;

  len = strlen(str);
  buf = ALLOCA_N(char, len * STRING_LEN_TIMES);
  ret_val = wkfDecodeMimeString(str, buf, sizeof(char) * len * STRING_LEN_TIMES, kout);
  if (ret_val == CONV_ERR) {
    rb_raise(rb_eRuntimeError, "Convert Error!!");
  }

  return rb_str_new2(buf);
}

static VALUE tohex(char *str)
{
  int ret_val;
  int len;
  char *buf;

  len = strlen(str);
  buf = ALLOCA_N(char, len * STRING_LEN_TIMES);
  ret_val = wkfStringToHexString(str, buf, sizeof(char) * len * STRING_LEN_TIMES);
  if (ret_val == CONV_ERR) {
    rb_raise(rb_eRuntimeError, "Convert Error!!");
  }

  return rb_str_new2(buf);
}

static VALUE mime_tohex(char *str)
{
  int ret_val;
  int len;
  char *buf;

  len = strlen(str);
  buf = ALLOCA_N(char, len * STRING_LEN_TIMES);
  ret_val = wkfMimeStringToHexString(str, buf, sizeof(char) * len * STRING_LEN_TIMES);
  if (ret_val == CONV_ERR) {
    rb_raise(rb_eRuntimeError, "Convert Error!!");
  }

  return rb_str_new2(buf);
}
%}

%include typemaps.i

#define UNKNOWN  -1
#define EUCorSJIS 0
#define ASCII     1
#define JIS       2
#define EUC       3
#define SJIS      4
#define BROKEN    5
#define DATA      6

#define LF   0
#define CR   1
#define CRLF 2

void print_guess_file(FILE *READ, VALUE detail = Qfalse);

int	guess_file(FILE *READ);
int	guess(char *str);
int	guess_string(char *str);

void convert_file(FILE *READ, int kout, FILE *WRITE, int kin = KC_UNKNOWN);
VALUE convert_string(char *sin, int kout, int kin = KC_UNKNOWN);
VALUE wkf(char *sin, int kout, int kin = KC_UNKNOWN);
VALUE tojis(char *str);
VALUE toeuc(char *str);
VALUE tosjis(char *str);


void set_line_end_code(int lineend);
void set_zenkaku2ascii_mode(VALUE flag);


VALUE encode_base64(char *str);
VALUE decode_base64(char *str);
void  decode_base64_file(FILE *READ, FILE *WRITE);

VALUE encode_qp(char *str);
VALUE decode_qp(char *str);
void  decode_qp_file(FILE *READ, FILE *WRITE);

VALUE decode_mime(char *str, int kout = KC_UNKNOWN);
VALUE tohex(char *str);
VALUE mime_tohex(char *str);
